Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## avrora.core.isdl.ast
Class CodeRebuilder.DepthFirst

    java.lang.Object
      avrora.core.isdl.ast.CodeRebuilder.DepthFirst

All Implemented Interfaces:
  CodeRebuilder

Direct Known Subclasses:
  StmtRebuilder.DepthFirst

Enclosing class:
  CodeRebuilder

public static class CodeRebuilder.DepthFirst
extends java.lang.Object
implements CodeRebuilder

The `DepthFirst` class is a base implementation of the `CodeVisitor` interface that visits the tree in depth-first order.

Nested Class Summary

Nested classes inherited from class avrora.core.isdl.ast.CodeRebuilder
`CodeRebuilder.DepthFirst`

Constructor Summary
`CodeRebuilder.DepthFirst()`

Method Summary
`Expr` | `visit(Arith.AddExpr e)`
`Expr` | `visit(Arith.AndExpr e)`
`Expr` | `visit(Arith.CompExpr e)`
`Expr` | `visit(Arith.DivExpr e)`
`Expr` | `visit(Arith.MulExpr e)`
`Expr` | `visit(Arith.NegExpr e)`
`Expr` | `visit(Arith.OrExpr e)`
`Expr` | `visit(Arith.ShiftLeftExpr e)`
`Expr` | `visit(Arith.ShiftRightExpr e)`
`Expr` | `visit(Arith.SubExpr e)`
`Expr` | `visit(Arith.XorExpr e)`
`Expr` | `visit(BitExpr e)`
`Expr` | `visit(BitRangeExpr e)`
`Expr` | `visit(CallExpr e)`
`Expr` | `visit(Literal.BoolExpr e)`
`Expr` | `visit(Literal.IntExpr e)`
`Expr` | `visit(Logical.AndExpr e)`
`Expr` | `visit(Logical.EquExpr e)`
`Expr` | `visit(Logical.GreaterEquExpr e)`
`Expr` | `visit(Logical.GreaterExpr e)`
`Expr` | `visit(Logical.LessEquExpr e)`
`Expr` | `visit(Logical.LessExpr e)`
`Expr` | `visit(Logical.NequExpr e)`
`Expr` | `visit(Logical.NotExpr e)`
`Expr` | `visit(Logical.OrExpr e)`
`Expr` | `visit(Logical.XorExpr e)`
`Expr` | `visit(MapExpr e)`
`Expr` | `visit(VarExpr e)`
`java.util.List` | `visitExprList(java.util.List l)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CodeRebuilder.DepthFirst

    public CodeRebuilder.DepthFirst()

Method Detail

### visit

    public Expr visit(Arith.AddExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Arith.AndExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Arith.CompExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Arith.DivExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Arith.MulExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Arith.NegExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Arith.OrExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Arith.ShiftLeftExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Arith.ShiftRightExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Arith.SubExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Arith.XorExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(BitExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(BitRangeExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visitExprList

    public java.util.List visitExprList(java.util.List l)

### visit

    public Expr visit(CallExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Literal.BoolExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Literal.IntExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Logical.AndExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Logical.EquExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Logical.GreaterEquExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Logical.GreaterExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Logical.LessEquExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Logical.LessExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Logical.NequExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Logical.NotExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Logical.OrExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(Logical.XorExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(MapExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

### visit

    public Expr visit(VarExpr e)

  Specified by:
    `visit` in interface `CodeRebuilder`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD